/***************************************************************************
 *   Copyright (C) 2004 by Armando Navarro Vázquez                         *
 *   armando@rmntec                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ANIMATION_H
#define ANIMATION_H

/**
@author Armando Navarro V�quez
*/
#include <qobject.h>
#include "molecule.h"
class QTimer;
class Animation : public QObject
{
  Q_OBJECT
public:
  Animation (CMolecule& molecule);
  ~Animation();
  void SetMode(int mode,int frame);
  int GetMode() const { return m_animationmode; }
  void SetFrame(int frame);
  void Start();
  void Stop();
  void Clear() { m_backup.clear(); }
  void Break();
  void BackupMolecule();
  void RestoreMolecule();
  bool IsActive() const; 

signals:
  void shot();
private slots:
  void  OnAnimationTimer();
private:
  CMolecule& m_molecule;
  int m_animationmode;
  QTimer* m_timer;
  std::vector<coordinate> m_backup;
  int m_interval;
  bool m_bfirst;
  int m_counter;
  int m_direction;
  /** store here the values for the distortions*/
  std::vector<int> m_previousframe;

};

#endif
